%include "syscall.inc"
global	getstr

section .text
getstr:	   ; arg1 = address, arg2 = length
	push ebp
	mov ebp, esp
	sub esp, 4	    ; [ebp-4] for I
	xor eax, eax
	mov [ebp-4], eax    ; I:=0
.again: mov eax, [ebp+8]    ; addr
	add eax, [ebp-4]    ; addr + I
	push eax
	syscall 3, 0, eax, 1
	cmp eax, 1
	jne .endstr
	pop eax
	mov bl, [eax]
	cmp bl, 10          ; EOL
	jne .noeol
	dec dword [ebp-4]   ; ignore the EOL char
	jmp .endstr
.noeol: mov eax, [ebp-4]    ; I
        inc eax
	cmp eax, [ebp+12]   ; I+1 <?> arg2
	jae .endstr
	inc dword [ebp-4]   ; I:=I+1
	jmp .again
.endstr:
	mov eax, [ebp+8]    ; addr
	add eax, [ebp-4]    ; addr + I
	inc eax
	xor bl, bl
	mov [eax], bl
	mov esp, ebp
	pop ebp
	ret
